/*
For the Macintosh World
to compile: javac -classpath .:KarelJRobot.jar kareltherobot/*.java
to run:   java -cp .:KarelJRobot.jar kareltherobot.Application
For the Windows World
to compile:  javac -classpath .;KarelJRobot.jar kareltherobot/*.java
to run: java -cp .;KarelJRobot.jar kareltherobot.Application
*/

//************************************

/*
This program instructs a robot to go count the number of intersections around a box in "box1.txt".   
A second robot then picks up enough beepers in the bottom left corner of the world to place 2 beepers on each of 
those intersections.

If there are not enough beepers to perform the task, the program says so in the console window and no second robot appears.

written by Scott McElfresh

*/

package kareltherobot;

public class Application implements Directions
{	
    public static void main(String[] args)
	{
		World.readWorld("box1.txt");	   
		World.setVisible(true);
		World.setTrace(false);
		World.setDelay(5);
		
		BoxRobot karel = new BoxRobot(3,3, East);  // puts robot at spot (3,3) with no beepers
		
		int numIntersections = karel.countAroundBox();
		karel.moveToBottom(); // moves to bottom street in the world, which avenue doesn't matter
							// facing any direction at this point is okay.
		karel.turnOff();
		
		
		System.out.println("There are " + numIntersections + " places around the box");
		
		if (numIntersections * 2 > 1000)
		{
		   System.out.println("There aren't enough beepers to do as you ask.");
		}
		else
		{
		   BoxRobot jane = new BoxRobot(North);  // puts robot at (1,1) with no beepers
		   jane.pickUpBeepers(numIntersections * 2);
		   jane.placeBeepersAtIntersections(2);
		   jane.moveToBottom();// moves to bottom street in the world, which avenue doesn't matter
							// facing any direction at this point is okay.
		   if (jane.anyBeepersInBeeperBag())
	                System.out.println("OOPS!!!!!!!!  Robot didn't put down all of its beepers.");
		   jane.turnOff();
		}
	}
}